<?php

/**
 * Implementiert einige Sicherheitseinstellungen wie Passwort ändern, etc.
 * @author Florian Kraatz <fk@beronet.com>
 * @author Silvia Mariné <smg@beronet.com>
 * @author Miguel Palmer <mp@beronet.com>
 */
class Security {

	private $_bc;
	private $_ba;

	function __construct() {
		$this->_bc = new beroConf('root');
		$this->_ba = new beroAri();
	}

	private function _set_ssh_login($enabled) {
		$this->_bc->set('root', 'ssh_admin_enable', (($enabled == '1') ? '1' : '0'));
		$passwd = '/usr/bin/passwd -' . (($enabled == 1) ? 'u' : 'l') . ' admin';
		exec('/bin/mount -oremount,rw /; ' . $passwd . '; /bin/mount -oremount,ro /');
	}

	private function _set_api_password($user, $pass) {
		require_once('/usr/local/php/include/apiusers.Class.php');
		$apiusers = new apiusers($pass);
		$apiusers->createFile();
	}

	private function _set_ssh_password($user, $pass) {
		exec('/usr/local/sbin/pwchange.sh admin ' . $pass);
	}

	private function _set_gui_password($user, $pass) {
		$pass_enc = tep_encrypt_password($pass);
		$this->_ba->update('UPDATE users SET password = \'' . $pass_enc . '\' WHERE user = \'' . $user . '\'');
	}

	private function _set_passwords($user, $pw_old, $pw_new, $pw_con) {

# we do not like empty passwords
		if ((strlen($pw_new) == 0) || (strlen($pw_old) == 0) || (strlen($pw_con) == 0)) {
			return(1);
		}

# old password should be correct
		$query = $this->_ba->select('SELECT password FROM users WHERE user = \'' . $user . '\'');
		$pw_chk = $this->_ba->fetch_array($query);
		if (tep_validate_password($pw_old, $pw_chk['password']) == false) {
			return(2);
		}
		unset($query);
		unset($pw_chk);

# new password should be the same as confirmation
		if (strcmp($pw_new, $pw_con) != 0) {
			return(3);
		}

		switch ($user) {
			case 'admin':
				$this->_set_api_password($user, $pw_new);
				$this->_set_ssh_password($user, $pw_new);
			case 'beroAdmin':
				$this->_set_gui_password($user, $pw_new);
				break;
		}

		return(0);
	}

	private function _apply_changes($session, $args) {
		if ($args['submit'] == 'Restore admin password and username') {
			$this->_set_api_password('admin', 'admin');
			$this->_set_ssh_password('admin', 'admin');
			$this->_set_gui_password('admin', 'admin');
		} else if ($args['a'] == 'save') {

			// only try to update password if some of the password-fields are set
			if ((strlen($args['pass_old']) != 0) || (strlen($args['pass_new']) != 0) || (strlen($args['pass_con']) != 0)) {
				$res = $this->_set_passwords($session['beroari_username'], $args['pass_old'], $args['pass_new'], $args['pass_con']);
				switch ($res) {
					case 1:
						$ret .= '<script>alert(\'' . SECURITY_EMP_PASS_ERROR_DIS . '\');</script>' . "\n";
						break;
					case 2:
						$ret .= '<script>alert(\'' . SECURITY_OLD_PASS_ERROR_DIS . '\');</script>' . "\n";
						break;
					case 3:
						$ret .= '<script>alert(\'' . SECURITY_CONFIRM_ERROR_DIS . '\');</script>' . "\n";
						break;
					default:
						$ret .= '<script>alert(\'' . SECURITY_SUCCES_MESSAGE_DIS . '\');</script>' . "\n";
						$ret .= '<script>$("#security_mess").hide();</script>';
				}
			}

			$this->_bc->set('root', 'api_disable', (($args['api_disable'] == '1') ? '1' : '0'));


			$this->_set_ssh_login($args['ssh_admin_enable']);
			$this->_ba->update('UPDATE set_app SET show_app=\'' . (($args['show_app'] == '1') ? '1' : '0') . '\'');

			$level = 1;
			if ((($this->_bc->get('root', 'safeguard') == '1') ? '1' : '0') != (($args['safeguard'] == '1') ? '1' : '0')) {
				$this->_bc->set('root', 'safeguard', (($args['safeguard'] == '1') ? '1' : '0'));
				$level = 2;
			}

			$ret .= Helper::activate($level, true, $_GET['m'], ACTIVATE);
		}

		return($ret);
	}

	function display() {
		$name = "SECURITY_TITLE_DIS";
		include('./includes/header.php');

		$alert = $this->_apply_changes($_SESSION, $_POST);
		if ($this->_ba->get('gui_mode') == 'simple')
			$simple_class = 'simple';

		$ret .= $this->_show_table($_GET['m'], $simple_class) . $alert;

		return $ret;
	}

	private function _show_api_session() {
		$query = $this->_ba->select('SELECT show_app FROM set_app');
		while ($entry = $this->_ba->fetch_array($query)) {
			return '<input type="checkbox" name="show_app" value="1"' . (($entry['show_app'] == '1') ? ' checked' : '') . '>';
		}
	}

	private function _show_ssh_enable() {

		$ret = '<input type="checkbox" name="ssh_admin_enable" value="1" ' . (($this->_bc->get('root', 'ssh_admin_enable') == 1) ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_api_disable() {

		$ret = '<input type="checkbox" name="api_disable" value="1" ' . (($this->_bc->get('root', 'api_disable') == '1') ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_safeguard() {

		$ret = '<input type="checkbox" name="safeguard" value="1" ' . (($this->_bc->get('root', 'safeguard') == 1) ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_table($module, $simple_class = null) {
		require_once '/usr/fallback/beroConf.php';
		require_once './includes/lang.php';
		ob_start();
		?>
		<br>
		<?php
		$ba = new beroAri();
		$query = $ba->select('SELECT password FROM users WHERE user = \'admin\'');
		$pw_chk = $ba->fetch_array($query);
		if (tep_validate_password('admin', $pw_chk['password']) !== false) {
			?>
			<div id='security_mess' class='text-center' style='margin-top:5px; color:red;'><? echo SECURITY_CHANGE_PASSWORD_MESSAGE_DIS ?></div>
			<?php
		}
		?>
		<br>
		<p class="text-center lead"><? echo SECURITY_TABLE_HEADER_DIS ?></p>
		<form name="security" id="security" method="POST" class="form-horizontal">
			<input name="fixChrome" type="password" style="display:none">
			<input type="hidden" name="m" value="<? echo $module ?>">
			<input type="hidden" name="f" value="action">
			<input type="hidden" name="a" value="save">
			<div class="form-group" data-toggle="tooltip" title="<? echo CHANGE_PWD_OLD_PASS ?>">
				<label for='pass_old' class='col-sm-5 control-label'><? echo SECURITY_OLD_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" name="pass_old" class="form-control input-sm" autocomplete="new-password">
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<? echo CHANGE_PWD_NEW_PASS ?>">
				<label for='pass_new' class='col-sm-5 control-label'><? echo SECURITY_NEW_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" name="pass_new" class="form-control input-sm" autocomplete="new-password">
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<? echo CHANGE_PWD_CONFIRM_NEW_PASS ?>">
				<label for='pass_con' class='col-sm-5 control-label'><? echo SECURITY_CONFIRM_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" class="form-control input-sm" name="pass_con" autocomplete="new-password">
				</div>
			</div>
			<!-- This is where the old thing was; we'd need to change the following in order to change the message (and change it wherever needed)
			-->
			<div class="form-group <? echo $simple_class ?>" data-toggle="tooltip" title="<? echo SECURITY_API_DISABLE ?>">
				<label for='api_disable' class='col-sm-5 control-label'><? echo SECURITY_DISABLE_API_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->_show_api_disable() ?>
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<? echo SECURITY_DISABLE_SESSION ?>">
				<label for='show_app' class='col-sm-5 control-label'><? echo SECURITY_DISABLE_SESSIONS_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->_show_api_session() ?>
				</div>
			</div>
			<div class="form-group <? echo $simple_class ?>" data-toggle="tooltip" title="<? echo SECURITY_SSH_ADMIN_ENABLE ?>">
				<label for='ssh_admin_enable' class='col-sm-5 control-label'><? echo SECURITY_ENABLE_SSH_ADMIN_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->_show_ssh_enable() ?>
				</div>
			</div>
			<div class="form-group <? echo $simple_class ?>" data-toggle="tooltip" title="<? echo SECURITY_SAFE_GUARD ?>">
				<label for='safeguard' class='col-sm-5 control-label'><? echo SECURITY_SAFE_GUARD_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->_show_safeguard() ?>
				</div>
			</div>
			<div class="text-center">
				<input name="submit" type="submit" class="btn btn-default" value="<? echo BUTTON_SAVE ?>">
			</div>
		</form>
		<script type="text/javascript">
			$('#security').validate({
				rules: {
					pass_new: {
						checkPassword: true,
					},
				}
			});
		</script>
		<?
		$ret .= ob_get_clean();

		return $ret;
	}

}
?>
